// Copyright (C) Maxime MORGE 2024
package org.scata.core

/**
  * Class representing a worker
  * @param name of the worker
  */
class Worker(val name : String) extends Ordered[Worker]{

  override def toString: String = name

  override def equals(that: Any): Boolean =
    that match {
      case that: Worker => that.canEqual(this) && this.name == that.name
      case _ => false
    }
  private def canEqual(a: Any) : Boolean = a.isInstanceOf[Worker]

  /**
    * Returns 0 if this an that are the same, negative if this < that, and positive otherwise
    * Workers are sorted with their name
    */
  def compare(that: Worker) : Int = {
    if (this.name == that.name) return 0
    else if (this.name > that.name) return 1
    -1
  }
}

/**
 * The default worker
 */
object NoWorker extends Worker("NoWorker"){
  override def toString: String = "NoWorker"
}
